
  //überträgt Webcambild
  //nimmt Screenshot für Weiterverarbeitung auf
  //passt Screenshot für den Lösungsalgorithmus an


  
void record() {
    
  PImage img;
  PImage imgCrop;
  
  if (cam.available()) cam.read();
    
  //binärer Schwarz-Weiß-Filter
  cam.filter (THRESHOLD, 0.6);
  image(cam, 0, 0);
  
  if (screen == true) {
      
  //Größe des Bildausschnitts, abhängig vom Aufbau
    int imgXStart = 150;
    int imgYStart = 17;
    int imgXEnd = 406;
    int imgYEnd = 408;
    
  //Start- und Endwerte für die einzelnen Felder des Rasters
    int xPixelStart = 0;
    int xPixelEnd = gridWidth;
    int yPixelStart = 0;
    int yPixelEnd = gridHeight;
  
  //Aufnahme und Zuschneiden des Screenshots
    saveFrame("kuerbis.png");
    img = loadImage("kuerbis.png");
    imgCrop = img.get(imgXStart, imgYStart, imgXEnd, imgYEnd);
    imgCrop.resize(640, 480);
    image(imgCrop, 0, 0);
      
    
  //füllt Array für Farbwerte jedes Pixels 
    for (int xPixels = 0; xPixels < myWidth; xPixels++) {
      for (int yPixels = 0; yPixels < myHeight; yPixels++) {
        
        colorsPixels[xPixels][yPixels] = get(xPixels, yPixels);
      }
    }
    
  //unterteilt Bild in ein Raster
    for (int xG = 0; xG <= mazeSize + 1; xG++) {
      for (int yG = 0; yG <= mazeSize + 1; yG++) {
      
        int whiteCount = 0;
      
  //zählt die weißen Pixel in den Feldern des Rasters
        if (xG >= 1 && xG <= mazeSize && yG >= 1 && yG <= mazeSize) {
          for (int xGridPixels = xPixelStart; xGridPixels < xPixelEnd; xGridPixels++) {
            for (int yGridPixels = yPixelStart; yGridPixels < yPixelEnd; yGridPixels++) {
            
              if (colorsPixels[xGridPixels][yGridPixels] == white) whiteCount++;
              else whiteCount--;
            }
          }
  //springt zum nächsten Feld in y-Richtung
          yPixelStart += gridHeight;
          yPixelEnd += gridHeight;
        }
  //speichert das Feld abhängig von whiteCount als schwarz oder weiß
        if (whiteCount > 0) colorsGrid[xG][yG] = white;
        else colorsGrid[xG][yG] = black;
      }
        
      if(xG >= 1 && xG < mazeSize + 1) {
  //springt zum nächsten Feld in x-Richtung
        xPixelStart += gridWidth;
        xPixelEnd += gridWidth;
  //fängt wieder am Anfang der Spalte an
        yPixelStart = 0;
        yPixelEnd = gridHeight;
      }
    }

  //zählt umliegende weiße Pixel
    for (int w = 1; w <= mazeSize; w++) {
      for (int h = 1; h <= mazeSize; h++) {
        if (colorsGrid[w + 1][h] == white) ways[w][h]++;
        if (colorsGrid[w - 1][h] == white) ways[w][h]++;
        if (colorsGrid[w][h + 1] == white) ways[w][h]++;
        if (colorsGrid[w][h - 1] == white) ways[w][h]++;
    
  //mögliche Wege = umliegende weiße Pixel - 1, da man von einem herkommt
        if (colorsGrid[w][h] == white) ways[w][h]--;
        else ways[w][h] = 0;
        
  //mögliche Wege für Sackgassen = 1, damit diese auch als Teil des Labyrinths erkannt werden
        if (colorsGrid[w][h] == white && ways[w][h] == 0) ways[w][h] = 1;
      
  //Anzahl der Kreuzungen = Anzahl der Pixel mit mehr als einem möglichen Weg
        if (ways[w][h] >= 2) crossingsCount++;
      }
    }
      
  //anpassen der möglichen Wege für Start- und Endpunkt
    ways[xEnd][yEnd] = 1;
    ways[xStart][yStart] = 1;
      
  //Arrays für genaue Positionen der Kreuzungen
    xCrossings = new int[crossingsCount + 1];
    yCrossings = new int[crossingsCount + 1];
      
    record = false;
  }
}